﻿Public Class Functions
    ''' <summary>
    ''' IPアドレスの取得
    ''' </summary>
    ''' <returns>IPアドレス</returns>
    ''' <remarks>IPアドレスの取得</remarks>
    Public Shared Function GetIP() As String
        Dim result As String = String.Empty
        Dim IP As String = String.Empty
        Try
            Dim i As Integer
            For i = 0 To System.Net.Dns.GetHostEntry(System.Net.Dns.GetHostName).AddressList.Length - 1
                IP = System.Net.Dns.GetHostEntry(System.Net.Dns.GetHostName).AddressList(i).ToString
                If IsIP(IP) Then
                    result = IP
                    Exit For
                End If
            Next
        Catch ex As Exception


        End Try

        Return result
    End Function

    ''' <summary>
    ''' IPアドレスチェック
    ''' </summary>
    ''' <param name="checkValue">チェックする値</param>
    ''' <returns>True:OK False:NG</returns>
    ''' <remarks>IPアドレスチェック</remarks>
    Public Shared Function IsIP(ByVal checkValue As String) As Boolean
        Return (System.Text.RegularExpressions.Regex.IsMatch(checkValue, "^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$"))
    End Function

End Class
