﻿Imports System.Net
Imports System.Net.Sockets
Imports System.Text
Imports System.Threading
Imports Sock
Imports Sock.F
Imports SockSample.Functions

Public Class Server



#Region "サーバーソケット"
    Private WithEvents RecvSock As New RecvSockClass   'サーバーソケット

    Private LastRecvIP As String
    Private LastRecvPort As String


    Private Sub RecvSockStart()
        With RecvSock
            .LocalIP = Me.LocalIP.Text
            .LocalPort = Me.LocalPort.Text
            .EndCheckChar() = New Byte() {}

            .RcvSockStart()

        End With
    End Sub


    Private Sub RecvSock_OnAcceptEnd(ByVal sender As Object, ByVal e As SockAcceptEndEventArgs) Handles RecvSock.OnAcceptEnd
        Call DispMsg("クライアントからの接続要求を受け付けました " & e.RemoteIP & ":" & e.RemotePort)
    End Sub

    Private Sub RecvSock_OnError(ByVal sender As Object, ByVal e As SockErrorEventArgs) Handles RecvSock.OnError
        Call DispMsg("[OnError]サーバーソケットエラー:" & e.ErrorType & ":" & e.Msg & " " & e.RemoteIP & ":" & e.RemotePort)
        Select Case e.ErrorType
            Case SockErrors.BindErr
                Call DispMsg("⇒[BindErr]サーバーソケットの作成に失敗しました:" & e.Msg)
            Case SockErrors.ListenErr
                Call DispMsg("⇒[ListenErr]接続待ち受け処理の開始に失敗しました:" & e.Msg)
            Case SockErrors.AcceptErr
                Call DispMsg("⇒[AcceptErr]クライアントからの接続要求の受付に失敗しました:" & e.Msg)
                'RecvSock.CloseSock(e.RemoteIP, e.RemotePort)
            Case SockErrors.BeginRecvErr
                Call DispMsg("⇒[BeginRecvErr]ソケットの受信開始に失敗しました:" & e.Msg)
                'RecvSock.CloseSock(e.RemoteIP, e.RemotePort)
                Call DispMsg("⇒クライアントからの接続を切断しました")
            Case SockErrors.RecvErr
                Call DispMsg("⇒[RecvErr]ソケットの受信に失敗しました:" & e.Msg)
                'RecvSock.CloseSock(e.RemoteIP, e.RemotePort)
                Call DispMsg("⇒クライアントからの接続を切断しました")

            Case SockErrors.SendErr
                Call DispMsg("⇒[SendErr]ソケットの送信に失敗しました:" & e.Msg)
            Case SockErrors.SendRetryOver
                Call DispMsg("⇒[SendRetryOver]ソケット送信がリトライアウトしました:" & e.Msg)

            Case SockErrors.OtherErr
                Call DispMsg("⇒[OtherErr]サーバーソケットエラー")
        End Select
    End Sub

    Private Sub RecvSock_OnListenEnd(ByVal sender As Object, ByVal e As SockListenEndEventArgs) Handles RecvSock.OnListenEnd
        Call DispMsg("[OnListenEnd]接続待ち受け処理を開始しました:" & e.LocalIP & ":" & e.LocalPort)
    End Sub

    Private Sub RecvSock_OnMessage(ByVal sender As Object, ByVal e As SockMessageEventArgs) Handles RecvSock.OnMessage
        Call DispMsg("[OnMessage]" & e.Msg)
    End Sub

    Private Sub RecvSock_OnRecvStart(ByVal sender As Object, ByVal e As SockReceiveStartEventArgs) Handles RecvSock.OnRecvStart
        Call DispMsg("[OnRecvStart]ソケット受信処理を開始しました->" & e.RemoteIP & ":" & e.RemotePort)
    End Sub

    Private Sub RecvSock_OnSendEnd(ByVal sender As Object, ByVal e As SockSendEndEventArgs) Handles RecvSock.OnSendEnd
        Call DispMsg("[OnSendEnd]" & e.LocalIP & ":" & e.LocalPort & " -> " & e.RemoteIP & ":" & e.RemotePort & " 送信内容=" & e.SendChar & " 送信Key=" & e.SendKey)
    End Sub

    Private Sub RecvSock_OnSendRetry(ByVal sender As Object, ByVal e As SockSendRetryEventArgs) Handles RecvSock.OnSendRetry
        Call DispMsg("[OnSendRetry]" & e.LocalIP & ":" & e.LocalPort & " -> " & e.RemoteIP & ":" & e.RemotePort & " " & e.RetryDo & "回目 送信Key=" & e.SendKey)
    End Sub


    Private Sub RecvSock_OnRecvEnd(ByVal sender As Object, ByVal e As SockReceiveEndEventArgs) Handles RecvSock.OnRecvEnd
        Call DispMsg("[OnRecvEnd]" & e.RemoteIP & ":" & e.RemotePort & " -> " & e.LocalIP & ":" & e.LocalPort & " 受信内容=" & Byte2String(HexChar2Byte(e.RecvChar)) & "(" & e.RecvChar & ") 送信Key=" & e.SendKey)

        LastRecvIP = e.RemoteIP
        LastRecvPort = e.RemotePort
        Call ResponseSend(e.RecvChar, e.SendKey)
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RecvSockStartBtn.Click
        Call RecvSockStart()
    End Sub

    Private Sub RecvSockSendBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RecvSockSendBtn.Click
        If LastRecvIP = String.Empty Then
            MsgBox("クライアントがありません")
            Return
        End If

        Call ResponseSend(String.Empty, String.Empty)
    End Sub


    Delegate Sub ResponseSendDelegate(ByVal recvChar As String, sendKey As String)
    Private Sub ResponseSend(ByVal recvChar As String, sendKey As String)
        If InvokeRequired Then
            ' 別スレッドから呼び出された場合
            Invoke(New ResponseSendDelegate(AddressOf ResponseSend), recvChar, sendKey)
            Return
        End If
        With RecvSock
            Dim sendParm As New RecvSockClass.SendParmClass
            With sendParm
                .SendKEY = Now '送信コマンドを識別する値

                Dim cmd As String = String.Empty
                cmd = "OK!!"
                If sendKey <> String.Empty Then
                    cmd &= " (" & sendKey & ")"
                End If
                .sndCmd = String2Byte(cmd)

                .SendTimeOut = 3000
                .SendRetry = 3
                .SendRetryWait = 2000
                .RemoteIP = LastRecvIP
                .RemotePort = LastRecvPort
            End With

            .SockSend(sendParm)
        End With


    End Sub

    Private Sub RecvSockEd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RecvSockStopBtn.Click
        RecvSock.CloseSockAll()
    End Sub

    Private Sub StatusCheck_Click(sender As System.Object, e As System.EventArgs) Handles StatusCheck.Click
        If RecvSock.IsAlive Then
            Call DispMsg("動作中")
        Else
            Call DispMsg("停止中")
        End If

    End Sub

#End Region


#Region "メッセージ表示関連"
    Delegate Sub DispMsgDelegate(ByVal msg As String)

    'メッセージ表示
    Public Sub DispMsg(ByVal msg As String)
        If InvokeRequired Then
            ' 別スレッドから呼び出された場合
            Invoke(New DispMsgDelegate(AddressOf DispMsg), msg)
            Return
        End If

        Dim lastMsg As String
        With lstMsg
            If .Items.Count = 0 Then
                lastMsg = ""
            Else
                lastMsg = .Items(.Items.Count - 1).ToString
            End If
        End With
        Call ListBoxAdd(lstMsg, Format(Now, "MM/dd HH:mm:ss.ff ") & msg, 100)

    End Sub

    'リストボックスに１行追加表示する
    Private Sub ListBoxAdd(ByVal lb As ListBox, ByVal msg As String, ByVal maxLine As Long)
        With lb

            .Items.Add(msg)
            If maxLine <> 0 Then '0の時は削除しない
                If .Items.Count > maxLine Then
                    .Items.RemoveAt(0)
                End If
            End If
            .SetSelected(.Items.Count - 1, True)
            .Refresh()
        End With

    End Sub

#End Region



    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.LocalIP.Text = GetIP()

    End Sub




    Private Sub DispClient_Click(sender As System.Object, e As System.EventArgs) Handles DispClient.Click
        Dim f As Form = New Client
        f.Show()
    End Sub
End Class
